//
//  ModelControler.m
//  3dMaze
//
//  Created by Ay on 09年2月2日.
//  Copyright 2009 NA. All rights reserved.
//

#import "ModelControler.h"
#import "Wrapper.h"
#import "CCTexture.h"
#import "CCSprite.h"
#import "CCMD2Model.h"

#define DISTANCT 35

@implementation ModelControler
@synthesize x;
@synthesize y;
@synthesize z;
@synthesize model;


- (id) initWithMD2PathAndTexture:(NSString *)path texture:(NSString *)texture;
{
	self = [super init];
	if (self != nil) {

		model = new CCMD2Model();
		model->Load([path UTF8String],  [texture UTF8String]);
		
		direction = NORTH;
		walkDistanct = 0;
		x = -20;
		y = 6.5;
		z = 0;
		r= 0;
		mode = STOP;
	}
	return self;
}

- (void) render{
	Enable3D();
	[self view];
	glRotatef(-90, 1, 0, 0);
	glRotatef( 90, 0, 1, 0);
	//glScalef(0.5, 0.5, 0.5);
	model->Render();
}

- (void) view{
	switch (mode) {
		case LEFT:
			r += 2;
			glRotatef(r, 1, 0, 0);
			if((int)r%90 == 0){
				mode = STOP;
			}
			glTranslatef(x,y, z);
			break;
		case RIGHT:
			r -= 2;
			glRotatef(r, 1, 0, 0);
			if((int)r % 90 == 0){
				mode = STOP;
			}
			glTranslatef(x,y, z);
			break;
		case FRONT:
			glRotatef(r, 1, 0, 0);
			[self walk:1];
			glTranslatef(x,y, z);
			
			break;
		case BACK:
			glRotatef(r, 1, 0, 0);
			[self walk:0];
			glTranslatef(x,y, z);			
			break;
		case STOP:
			glRotatef(r, 1, 0, 0);
			glTranslatef(x,y, z);
			
			break;
		default:
			break;
	}
}

- (void) walk:(int)d{
	walkDistanct++;
	switch (direction) {
		case NORTH:
			if(d==1)
				z++;
			else
				z--;
			break;
		case SOUTH:
			if(d==1)
				z--;
			else
				z++;
			break;
		case EAST:
			if(d==1)
				y--;
			else
				y++;
			break;
		case WEST:
			if(d==1)
				y++;
			else
				y--;
			break;
		default:
			break;
	}
	if((int)walkDistanct % DISTANCT == 0){
		mode = STOP;
		walkDistanct = 0;
	}
}
- (bool) viewMode:(int)m{
	if(mode!=STOP)
		return false;
	
	if(m == LEFT){
		direction = ( direction + 3) % 4;
	}
	
	if(m == RIGHT){
		direction = ( direction + 5) % 4;
	}
	
	mode = m;
	return true;
}
@end
